#include <VSDL.h>
#include <stdlib.h>
#include <GL/gl.h>
#include "world.h"
#include "main.h"

#define FPS        100

int WOBBLING = 0 ;
int RETOURNE = 0 ; 

int arcade() {
   SDL_Event event ;
   Uint8* keyMap ;
   int jx, jy ;
   GLenum gl_error ;
   int t1, t2 ;
   int i, j ;
   int action ;
   int fps ;
   int period ;
   char levelFile[256] ;
   int level ;
   int levelUp ;
   int result ;
   World* world ;
   
   /*--- init Open GL ----------------------------*/
   glMatrixMode( GL_PROJECTION) ;
   glLoadIdentity() ;
   glFrustum( -1.0, 1.0, -1.0, 1.0, 1.0, 200.0) ;
   glViewport( 0, 0, 640, 480) ;
   glMatrixMode( GL_MODELVIEW );
   glLoadIdentity( );   
   /*--- End of init ------------------------------*/
   
   world = new World ;
   level = 0 ;
   while( 1) {
      level += 1 ;
      levelUp = 0 ;
      if ( level > 9 ) {
	 SDL_Quit() ;
	 exit( 0) ;
      }
      sprintf( levelFile, "level%02d.map", level) ;
      if ( world->Load( levelFile) == 0 ) {
	 SDL_Quit() ;
	 exit( 0) ;
      }
      fps = FPS ;
      t1 = SDL_GetTicks() ;
      period = 0 ;
      while( !levelUp) {   
	 t2 = t1 ;
	 t1 = SDL_GetTicks() ;
	 period += t1 - t2 ;
	 j = period / 5 ; /* every 5 ms */
	 period = period % 5 ;
	 for(i=0;i<j;i++) {
	    action = 0 ;
	    while( SDL_PollEvent(&event) ) {      
	       if ( event.type == SDL_QUIT ) {
		  SDL_Quit() ;
		  exit(0) ;
	       }
	       if ( event.type == SDL_JOYBUTTONDOWN ) {
		  action |= BALL_JUMP ; 
	       }
	    }
	    jx = SDL_JoystickGetAxis( joystick, 0) / 16000 ;
	    jy = SDL_JoystickGetAxis( joystick, 1) / 16000 ;
	    keyMap = SDL_GetKeyState( NULL) ;
	    if ( keyMap[SDLK_ESCAPE] ) {
	       delete world ;
	       return( 0) ;
	    }
	    if ( keyMap[SDLK_u] ) /* Wil be removed of course ;) */
	      levelUp = 1 ;
	    if ( keyMap[SDLK_w] )
	      WOBBLING = 10 ;
	    if ( keyMap[SDLK_x] )
	      RETOURNE = 10 ; 
	    if ( keyMap[SDLK_LEFT] || jx <= -1)
	      action |= BALL_MOVE_LEFT ;
	    if ( keyMap[SDLK_RIGHT] || jx >= 1)
	      action |= BALL_MOVE_RIGHT ;
	    if ( keyMap[SDLK_UP] || jy <= -1)
	      action |= BALL_ACCEL ;
	    if ( keyMap[SDLK_DOWN] || jy >= 1)
	      action |= BALL_BRAKE ;	 
	    if ( keyMap[SDLK_SPACE] )
	      action |= BALL_JUMP ;
	    
	    world->Move( action) ;
	
	    result = world->Update() ;
	    if ( result == 1 )
	      levelUp = 1 ;
	 }      
	 	 
	 /*--- Clearing scene -------------------------------*/
	 glEnable(GL_DEPTH_TEST) ;
	 glDepthMask(GL_TRUE) ;
	 glClearColor( 0.0, 0.0, 0.0, 1.0) ;
	 glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT) ;
	 /*--- End of Clearing ------------------------------*/
	 
	 world->Display() ;
	 fps = VSDL_WaitFrame( FPS) ;
	 SDL_GL_SwapBuffers() ;    /* Update the image */
	 gl_error = glGetError() ; /* Check for OPENGL error */
	 if( gl_error != GL_NO_ERROR ) {
	    fprintf( stderr, "testgl: OpenGL error: %x\n", gl_error) ;
	 }
      }
   }
   return( 0) ;
}
