#ifndef _BALL_H
#define _BALL_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <VSDL.h>
#include <GL/gl.h>

#define BALL_MOVE_LEFT   1
#define BALL_MOVE_RIGHT  2
#define BALL_ACCEL       4
#define BALL_BRAKE       8
#define BALL_JUMP        16
#define BALL_SIZE        0.15
#define BALL_Z_ADVANCE   1.2
#define BALL_MIN_SPEED   0.001
#define BALL_MAX_SPEED   0.03

class World ;

class Ball {
   friend World ; 
 public:
   Ball() ;
   ~Ball() ;
   int Move( int dir) ;
   int Update() ;
   void Fall( float x, float z) ;
   void Glue() ;
   void Display() ;
 private:  
   float size ;
   float minSpeed ;
   float maxSpeed ;
   float posX ;
   float posY ;
   float posZ ;
   float speed ;
   int jumping ;
   int falling ;
   int nbLives ;
   int score ;
   float fallX ;
   float fallZ ;
   VSDL_sound* sfxJump ;
   VSDL_sound* sfxFall ;   
} ;

#endif ;
