#include <VSDL.h>
#include <stdlib.h>
#include <GL/gl.h>
#include "main.h"
#include "intro.h"

#define FPS        50

int intro() {
   SDL_Event event ;
   GLenum gl_error ;
   int t1, t2 ;
   int i, j ;
   int fps ;
   int period ;
   GLuint pic1, pic2 ;
   float rotation ;
   
   pic1 = VSDL_LoadTexture( "intro1.jpg") ;
   pic2 = VSDL_LoadTexture( "intro2.jpg") ;
   SDL_ShowCursor( 0) ;
   /*--- init Open GL ----------------------------*/
   glMatrixMode( GL_PROJECTION) ;
   glLoadIdentity() ;
   glFrustum( -1.0, 1.0, -1.0, 1.0, 1.0, 100.0) ;
   glViewport( 0, 0, 640, 480) ;
   glMatrixMode( GL_MODELVIEW );
   glLoadIdentity( );   
   /*--- End of init ------------------------------*/
   
   rotation = 0.0 ;
   fps = FPS ;
   t1 = SDL_GetTicks() ;
   period = 0 ;
   while( 1) {
      t2 = t1 ;
      t1 = SDL_GetTicks() ;
      period = period + t1 - t2 ;
      j = period / 5 ; /* every 5 ms */
      period = period % 5 ;
      for(i=0;i<j;i++) {
	 while( SDL_PollEvent(&event) ) {      
	    if ( event.type == SDL_QUIT ) {
	       SDL_Quit() ;
	       exit(0) ;
	    }
	    if ( event.type == SDL_KEYDOWN ) {
	       return( 0) ;     
	    }
	 }
      }      
      /*--- Clearing scene -------------------------------*/
      glEnable(GL_DEPTH_TEST) ;
      glDepthMask(GL_TRUE) ;
      glClearColor( 0.0, 0.0, 0.0, 1.0) ;
      glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT) ;
      glLoadIdentity() ;
      /* --- And display ---------------------------------*/
      glTranslatef( 0.0, 0.0, -2.0 ) ;
      glRotatef( rotation+90, 1.0, 0.0, 0.0) ;
      if ( rotation < 180 )
	glBindTexture( GL_TEXTURE_2D, pic1 ) ;
      else
	glBindTexture( GL_TEXTURE_2D, pic2 ) ;
      glEnable( GL_TEXTURE_2D) ;
      glBegin( GL_QUADS) ;
      glTexCoord2f( 0.0, 0.0) ; glVertex3f( -1.0, -1.0, 0.0) ;
      glTexCoord2f( 1.0, 0.0) ; glVertex3f( 1.0, -1.0, 0.0) ;
      glTexCoord2f( 1.0, 1.0) ; glVertex3f( 1.0, 1.0, 0.0) ;
      glTexCoord2f( 0.0, 1.0) ; glVertex3f( -1.0, 1.0, 0.0) ;
      glEnd() ;
      glDisable( GL_TEXTURE_2D) ;
      
      rotation += 1.0 ;
      if ( rotation > 360.0 )
	rotation -= 360.0  ;
      fps = VSDL_WaitFrame( FPS) ;
      SDL_GL_SwapBuffers( ) ;
      /* Check for OPENGL error */
      gl_error = glGetError( );
      if( gl_error != GL_NO_ERROR ) {
	 fprintf( stderr, "testgl: OpenGL error: %x\n", gl_error) ;
      }  
   }
   return( 0) ;
}
