/* 
  -+-------------------------------------------------------------------------+-
    Balloon Rally                                       Release 0.1 June 2000
                         
                          -+------------------+-
                             The Main Program
                          -+------------------+-

  -+------------------------------------------------------------------------+- 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Jean-Christophe Duberga, 
    duberjc@voila.fr
    10, Rue Solesse
    33290 BLANQUEFORT
    FRANCE
  -+-------------------------------------------------------------------------+-
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <VSDL.h>
#include "intro.h"
#include "hiscore.h"
#include "arcade.h"
#include "main.h"

#define RELEASE      "0.1 (alpha)"

char dataPath[256] ;
SDL_Joystick* joystick ;

int main( int argc, char* argv[]) {
   int state ;
   int i ;
   int flags ;
   int bpp ;
   
   /* Process parameters */
   strncpy( dataPath, DATA_PATH, 256) ;
   flags = VSDL_GL|VSDL_FULLSCREEN ;
   bpp = 0 ; /* keep default system bpp */
   for(i=1;i<argc;i++) {
      if ( strcmp( argv[i], "--help") == 0 ) {
	 printf("usage: %s [options]\n\n", argv[0]) ;
	 printf("options are:\n") ;
	 printf("  --help        Display this help notice\n") ;
	 printf("  --fullscreen  Play in fullscreen (default)\n") ;
	 printf("  --window      Play windowed \n") ;
	 printf("  --bpp <bpp>   Change bpp (not yet implemented)\n") ; 
	 printf("  --nosound     Disable the sound\n") ;
	 printf("  --path <path> Path for the data (defualt=%s\n)", DATA_PATH) ;
	 printf("\n") ;
	 exit( 1) ;
      }
      else if ( strcmp( argv[i], "--window") == 0 )
	flags = flags & ~VSDL_FULLSCREEN ;
      else if ( strcmp( argv[i], "--bpp") == 0 )
	bpp = atoi( argv[++i]) ;
      else if ( strcmp( argv[i], "--nosound") == 0 )
	;
      else if ( strcmp( argv[i], "--path") == 0 ) {
	 i++ ;
	 strcpy( dataPath, argv[i]) ;
      }
   }
   VSDL_SetPath( DATA_PATH) ;
   VSDL_SetMode( 640, 480, flags) ;
   VSDL_OpenMixer( 44100, 16, 2 ) ;
   SDL_WM_SetCaption( "Balloon Raly", "Ballon Rally" ) ;
   printf( "Thank you for trying Balloon Rally %s\n", RELEASE) ;
   
   SDL_Init( SDL_INIT_JOYSTICK) ;
   joystick = SDL_JoystickOpen( 0) ;
   printf("JOYSTICK-1--------->%s\n",SDL_JoystickName( 0)) ;
   printf("JOYSTICK-2--------->%s\n",SDL_JoystickName( 1)) ;
   printf("JOYSTICK-3--------->%s\n",SDL_JoystickName( 2)) ;
   printf("JOYSTICK-4--------->%s\n",SDL_JoystickName( 3)) ;
   
   
   state = GO_ARCADE ;
   while( 1) {
      switch( state) {
       case GO_EXIT:
	 SDL_Quit() ;
	 exit(0) ;
       case GO_ARCADE:
	 intro() ;
//	 hiScore() ;
	 arcade() ;
	 SDL_Quit() ;
	 exit(0) ;
      }
   }
}
