#include "stars.h"

Stars::Stars( int nb, float nleft, float nright, float nbottom, float ntop) {
   int i ;
   
   nbStars = nb ;
   left = nleft ;
   right = nright ;
   bottom = nbottom ;
   top = ntop ;
   if ( nbStars > STARS_MAX_STARS )
     nbStars = STARS_MAX_STARS ;
   for(i=0;i<nbStars;i++) {
      X[i] = (float)( rand() % 1000 ) * ( right - left ) / 1000.0 + left;
      Y[i] = (float)( rand() % 1000 ) * ( top - bottom ) / 1000.0 + bottom;
      Z[i] = rand()%10000 ;
      S[i] = rand()%5 + 1 ;
   }
}

Stars::~Stars() {
   
   
}

void Stars::Go( float speed ) {
   int i ;
   
   for(i=0;i<nbStars;i++) {
      Z[i] = Z[i] - ( speed * S[i] ) ;
      if ( Z[i] < 1000 ) {
	 X[i] = (float)( rand() % 1000 ) * ( right - left ) / 1000.0 + left ;
	 Y[i] = (float)( rand() % 1000 ) * ( top - bottom ) / 1000.0 + bottom ;
	 Z[i] = rand()%10000 ;
	 S[i] = rand()%3 + 1 ;
      }
   }
}

void Stars::Display() {
   int i ;
   
   glBegin( GL_POINTS) ;
   for(i=0;i<nbStars;i++) {
      glColor4f( 2000.0/Z[i], 2000.0/Z[i], 2000.0/Z[i], 1.0) ;
      glVertex3f( X[i], Y[i] , -Z[i]/500.0) ;
   }
   glEnd() ;
}
