#include "track.h"
#include <iostream.h>
#include <fstream.h> 
#include <math.h>

Track::Track() {

   lenght = 0 ;
   nbTypes = 0 ;
   loaded = TRACK_UNLOADED ;
}

Track::~Track() {
   
   UnLoad() ;
}

int Track::Load( char* fileName) {
   int i ;
   ifstream mapFile ;

   if ( loaded == TRACK_LOADED )
     UnLoad() ;
   printf("Track: loading file: %s\n", fileName) ;
   mapFile.open( fileName) ;
   mapFile >> nbTypes ;
   for(i=0;i<nbTypes;i++) {
      mapFile >> textureNames[i] ;
      textures[i] = VSDL_LoadTexture( textureNames[i]) ;
   }
   mapFile >> backName ;
   BACK = VSDL_LoadTexture( backName) ;
   mapFile >> lenght ;
   for(i=0;i<lenght;i++)
     mapFile >> map[i] ;
   mapFile.close() ;
   
   stars = new Stars( 200, -10.0, 10.0 , -10.0, 10.0) ;
   loaded = TRACK_LOADED ;
   return( 1) ;
}

int Track::UnLoad() { 
   
   if ( loaded == TRACK_LOADED) {
      glDeleteTextures( 1, &BACK) ;
      //   glDeleteTextures( nbTypes, textures ) ;
   }
   return( 1) ;
}

int Track::Update( float speed) {
   
   stars->Go( speed) ;
   return( 1) ;
}

void Track::Display( float posZ) {
   int i,j ;
   int type ;
   float dist ;
   
   dist = ( -posZ / CASE_W / (float)lenght) * 0.5 ;
   glBindTexture( GL_TEXTURE_2D, BACK ) ;
   glEnable( GL_TEXTURE_2D) ;
   glColor4f( 1.0, 1.0, 1.0, 1.0);
   glBegin( GL_QUADS) ;
   glTexCoord2f( 0.0+dist, 0.0+dist) ; glVertex3f(-2.0,-2.0,-2.0) ;
   glTexCoord2f( 1.0-dist, 0.0+dist) ; glVertex3f(2.0,-2.0,-2.0) ;
   glTexCoord2f( 1.0-dist, 1.0-dist) ; glVertex3f(2.0,2.0,-2.0) ;
   glTexCoord2f( 0.0+dist, 1.0-dist) ; glVertex3f(-2.0,2.0,-2.0) ;   
   glEnd() ;
   glDisable( GL_TEXTURE_2D) ;
   glClear( GL_DEPTH_BUFFER_BIT) ;
   stars->Display() ;   
   for(j=0;j<TRACK_VISIBILITY;j++)
     for(i=0;i<TRACK_WIDTH;i++) {
	type = map[j+(int)((float)(-posZ/CASE_W))][i] ;
	if ( type != '0' ) {
	   DrawCase(TRACK_X+(float)i*CASE_W, 
		    TRACK_Y,
		    TRACK_Z+(float)(j)*CASE_W+fmod( posZ, CASE_W),
		    textures[type-49]) ;
	}
     }
}

void Track::DrawCase( float x, float y, float z, GLuint tex) {
  
   glBindTexture( GL_TEXTURE_2D, tex) ;
   glEnable( GL_TEXTURE_2D) ;
   glColor4f( 1.0, 1.0, 1.0, 1.0) ;
   glBegin( GL_QUADS) ;
   /* Top face */
   glTexCoord2f(0.0f, 0.0f) ; glVertex3f( x, y, -z) ;
   glTexCoord2f(1.0f, 0.0f) ; glVertex3f( x+CASE_W, y, -z) ;
   glTexCoord2f(1.0f, 1.0f) ; glVertex3f( x+CASE_W, y, -z-CASE_W) ;
   glTexCoord2f(0.0f, 1.0f) ; glVertex3f( x, y, -z-CASE_W) ;
   glEnd() ;
   glDisable( GL_TEXTURE_2D) ;
   
   glColor4f( 0.5, 0.2, 0.2, 1.0) ;
   glBegin( GL_QUADS) ;
   /* Front face */
   glVertex3f( x, y, -z) ;
   glVertex3f( x+CASE_W, y, -z) ;
   glVertex3f( x+CASE_W, y-CASE_H, -z) ;
   glVertex3f( x,y-CASE_H, -z) ;
   /* Right face */
   glVertex3f( x+CASE_W, y, -z) ;
   glVertex3f( x+CASE_W, y-CASE_H, -z) ;
   glVertex3f( x+CASE_W, y-CASE_H, -z-CASE_W) ;
   glVertex3f( x+CASE_W, y, -z-CASE_W) ; 
   /* Back face not needed in fact */
   glVertex3f( x, y, -z-CASE_W) ;
   glVertex3f( x+CASE_W, y, -z-CASE_W) ;
   glVertex3f( x+CASE_W, y-CASE_H, -z-CASE_W) ;
   glVertex3f( x, y-CASE_H, -z-CASE_W) ;
   /* Left face */
   glVertex3f( x, y, -z) ;
   glVertex3f( x, y, -z-CASE_W) ;
   glVertex3f( x, y-CASE_H, -z-CASE_W) ;
   glVertex3f( x, y-CASE_H, -z) ;
   glEnd() ;
}
