#ifndef _TRACK_H
#define _TRACK_H

#include <stdio.h>
#include <stdlib.h>
#include <VSDL.h>
#include <GL/gl.h>
#include "stars.h"

#define TRACK_WIDTH       6
#define TRACK_MAX_LONG    1000
#define TRACK_MAX_TEX     255
#define CASE_W            0.4
#define CASE_H            0.10
#define TRACK_X           -1.2   /* - NBCASES * CASE_W / 2 to center the track */
#define TRACK_Y           -1.0
#define TRACK_Z           0.0
#define TRACK_VISIBILITY  25
#define TRACK_UNLOADED    0
#define TRACK_LOADED      1

class World ;

class Track {
   friend World ;
 public:
   Track() ;
   ~Track() ;
   int Load( char* fileName) ;
   int UnLoad() ;
   int Update( float speed) ;
   void Display( float posZ) ;
   void DrawCase( float x, float y, float z, GLuint tex) ;
 private:
   int lenght ;
   char map[TRACK_MAX_LONG][TRACK_WIDTH] ;
   int nbTypes ;
   char textureNames[TRACK_MAX_TEX][256] ;
   GLuint textures[TRACK_MAX_TEX] ;
   char backName[256] ;
   GLuint BACK ;
   Stars* stars ;
   int loaded ;
} ;

#endif 
