#include "world.h"

extern int WOBBLING ;
extern int RETOURNE ;

World::World() {

   track = new Track ;
   ball = new Ball ;
   fonts = VSDL_LoadTexture( "fa1.jpg") ;
   chrono = 0 ;
}

World::~World() {
   
   delete track ;
   delete ball ;
}

int World::Load( char* fileName) {

   ball->posZ = 0 ;
   chrono = 0 ;
   return( track->Load( fileName)) ;
}

int World::Move( int dir) {
   
   ball->Move( dir) ;
   return( 1) ;
}

int World::Update() {
   int caseX, caseZ ;
   char type ;
   
   chrono += 5 ; /* Updated every 5 ms */
   track->Update( ball->speed*100.0) ;
   ball->Update() ;
   if ( (!ball->jumping) && (!ball->falling) ){
      caseX = (int)((ball->posX-TRACK_X)/CASE_W) ;
      caseZ = (int)(-(ball->posZ-BALL_Z_ADVANCE)/CASE_W) ;
      type = track->map[caseZ][caseX] ;
      if ( type == '0' )
	ball->Fall((float)caseX*CASE_W+TRACK_X+CASE_W/2.0 , 
		   (float)(-caseZ)*CASE_W+BALL_Z_ADVANCE+CASE_W/2.0);
      else if ( type == '2' )
	ball->Move( BALL_JUMP) ;  
      else if ( type == '3' )
	ball->Glue() ;
   }
   if ( -ball->posZ/CASE_W > track->lenght-TRACK_VISIBILITY ) {
      ball->score += 1250 ;
      return( 1) ;
   }
   return( 0) ;
}
void World::Display() {
   char dispChrono[256] ;
   char dispScore[256] ;
   
   glLoadIdentity() ;
   if ( RETOURNE > 0 ) {
      RETOURNE -= 1 ;
      glRotatef( 180.0, 0.0, 0.0, 1.0) ;
   }
   if ( WOBBLING > 0 ) {
      WOBBLING -=1 ;
      glTranslatef( (float)(rand()%2)/20.0,(float)(rand()%2)/20.0,(float)(rand()%2)/20.0) ;
   }
   track->Display( ball->posZ) ;
   ball->Display() ;
   sprintf( dispChrono, "%02d:%02d", chrono/1000, (chrono%1000)/10) ;
   VSDL_glPrint( 0.5, 0.9, 1.0, fonts, "TIME:") ;
   VSDL_glPrint( 0.5, 0.8, 1.0, fonts, dispChrono) ;
   VSDL_glPrint( -1.0, 0.9, 1.0, fonts, "SCORE:") ;
   sprintf( dispScore, "%06d",ball->score) ;
   VSDL_glPrint( -1.0, 0.8, 1.0, fonts, dispScore) ;
}
   
